<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import VideoModal from '~/components/solutions/video-modal.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

interface HeroButton {
  text: string;
  href: string;
  variant?: string;
  icon?: {
    name: string;
    variant: string;
    size?: string;
  };
  dataGaName?: string;
  dataGaLocation?: string;
}

interface HeroVideo {
  video_url: string;
  mp4_url: string;
  webm_url: string;
}

interface Banner {
  text: string;
  href: string;
  show: boolean;
  data_ga_name?: string;
  data_ga_location?: string;
}

interface HeroImage {
  src: string;
  alt?: string;
}

export default Vue.extend({
  components: {
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    description: {
      type: String,
      required: false,
      default: '',
    },
    button: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: false,
      default: null,
    },
    video: {
      type: Object as PropType<HeroVideo>,
      required: false,
      default: null,
    },
    banner: {
      type: Object as PropType<Banner>,
      required: false,
      default: null,
    },
  },
  data: () => ({
    showModal: false,
  }),
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <div class="hero-text">
          <a
            v-if="banner.show === true"
            :href="banner.href"
            class="banner"
            :data-ga-name="banner.data_ga_name"
            :data-ga-location="banner.data_ga_location"
          >
            <!-- <img
              class="gartner-logo"
              src="/nuxt-images/logos/gartner-white.svg"
              alt="Gartner icon"
            /> -->
            <SlpTypography variant="body3">{{ banner.text }}</SlpTypography>
            <SlpButton variant="tertiary" class="arrow-icon">
              <SlpIcon class="slp-ml-8" variant="product" name="arrow-right" />
            </SlpButton>
          </a>
          <img
            src="/nuxt-images/solutions/ai/duo-logo.svg"
            class="slp-mb-24 logo-image"
            rel="preload"
            alt=""
          />
          <div>
            <SlpTypography
              v-if="header"
              variant="heading1-bold"
              tag="h1"
              class="slp-mb-24"
              >{{ header }}</SlpTypography
            >
          </div>
          <div>
            <SlpTypography variant="heading5" tag="h1" class="description">{{
              description
            }}</SlpTypography>
          </div>
          <div class="hero-container__buttons">
            <SlpButton
              :href="button.href"
              :variant="button.variant"
              class="slp-mt-24"
              :data-ga-name="button.dataGaName"
              :data-ga-location="button.dataGaLocation"
              >{{ button.text }}
              <SlpIcon v-if="button.icon" v-bind="button.icon" class="slp-ml-8"
            /></SlpButton>
          </div>
        </div>
      </div>
    </SlpContainer>
    <div v-if="video" class="wrapper" @click="openModal()">
      <SlpIcon
        class="play-icon"
        name="play-circle"
        variant="marketing"
        size="96"
      />
      <video class="video-looping" autoplay loop muted playsinline>
        <source :src="video?.mp4_url" type="video/mp4" />
        <source :src="video?.webm_url" type="video/webm" />
      </video>
    </div>
    <SlpContainer>
      <VideoModal
        v-show="showModal && video?.video_url"
        :visible="showModal"
        @close="showModal = false"
      >
        <template #body>
          <lite-vimeo
            :videoid="getVimeoVideoId(createVideoSource(video?.video_url))"
            autoplay
          ></lite-vimeo>
        </template>
      </VideoModal>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  padding: $spacing-96 0 0 0;
  position: relative;
  z-index: 1;

  .hero-container__buttons {
    :deep .slp-btn {
      @media (max-width: $breakpoint-sm) {
        width: 100%;
        justify-content: center;
      }
    }
  }
}

.hero-wrapper {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 4%;
  }

  .description {
    color: $color-surface-400;
    max-width: 600px;
    margin: auto;
  }

  .slp-btn {
    border-color: $color-surface-50;
  }

  .hero-text {
    color: $color-text-50;
    margin-top: $spacing-32;
    text-align: center;

    @media (min-width: $breakpoint-md) {
      padding-top: 0;
    }
  }
}

.hero-pill {
  margin-bottom: 16px;
  background: $color-surface-900;
  position: relative;
  padding: 4px 8px;
  display: inline-block;
  font-weight: 600;
  width: 100%;
  border-radius: 28px;
  cursor: pointer;
  opacity: 0;
  animation: opacity-intro 0.9s linear forwards 1.2s;

  &:hover {
    .slp-icon {
      transform: translateX(8px);
    }
  }

  .slp-icon {
    transition: transform 0.2s ease-in-out;
    margin-bottom: 3px;
    transform: translateX(4px);
  }

  a {
    display: flex;
    color: $color-text-300;
    align-content: center;
    position: relative;
    align-items: center;
    z-index: 1;
    @media (max-width: $breakpoint-md) {
      img {
        margin-right: $spacing-4;
      }
    }
  }
  span {
    margin: 0 4px;
    @media (max-width: $breakpoint-md) {
      margin: 0 4px 0 0;
    }
  }
  .pill-link {
    font-weight: 400;
  }
}
.logo-image {
  max-height: 46px;
}
.logo-image {
  @media (max-width: $breakpoint-lg) {
    max-width: 100%;
  }
}

.banner {
  display: flex;
  justify-content: space-between;
  padding: 8px 16px;
  align-items: center;
  animation: opacity-intro 0.9s linear forwards 0.8s;
  border-radius: 20px;
  background: linear-gradient(
    0deg,
    rgba(225, 152, 109, 0.1) 0%,
    rgba(110, 67, 211, 0.1) 100%
  );
  color: $color-text-50;
  margin-bottom: $spacing-64;
  border: 1px solid $color-surface-600;

  &:hover {
    .slp-icon {
      transform: translateX(8px);
    }
  }

  .gartner-logo {
    max-height: 13px;
  }

  .arrow-icon {
    color: $color-text-50;
    font-size: 16px;
    text-decoration: underline;
    padding: 0;
    font-weight: 400;
    justify-content: flex-end;
    min-width: unset;
  }
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 150%, 0);
  }
  to {
    transform: translate3d(0, 0%, 0);
  }
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}

.wrapper {
  position: relative;
  cursor: pointer;
  margin-top: $spacing-96;

  .play-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 48px;
    color: $color-surface-700;
    cursor: pointer;
    z-index: 2;
    border: 2px solid $color-surface-600;
    border-radius: 9999px;
    box-sizing: content-box;

    ::v-deep path {
      fill: $color-surface-50;
      transition: color 0.2s ease;
    }

    ::v-deep circle {
      transition: color 0.2s ease;
    }
  }

  lite-video {
    &:deep iframe {
      left: 0;
    }
  }
  .video-looping {
    width: 100%;
    filter: brightness(0.6);

    &:hover {
      .play-icon::v-deep {
        color: #1e1d43;
      }
    }
  }

  &:hover {
    .thumbnail-image {
      filter: brightness(0.9);
    }

    .play-icon::v-deep {
      circle {
        color: #1e1d43;
      }
      path {
        color: $color-surface-50;
      }
    }
  }

  .thumbnail-image {
    position: relative;
    display: block;
    cursor: pointer;
    width: 100%;
    height: 100%;
    max-height: 600px;
    object-fit: cover;
    object-position: center;
    transition: all 0.2s ease;
  }
}
</style>
